Bug 484580 - ltsp - unable to read any file from client mounted usb memory sticks
ltsp - unable to read any file from client mounted usb memory sticks
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: ltspfs (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Warren Togami
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-08 12:22 EST by John Ellson
Modified: 2010-06-28 07:12 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 07:12:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description John Ellson 2009-02-08 12:22:59 EST
Description of problem:
I can plugin a usb memory stick into a client, can open a nautilus window on the mount, and can see icons for the folders and files on the mount, can open folders, but attempting to read any file with any application results in an error.

The problem is always a failure to allocate memory during read()


Version-Release number of selected component (if applicable):
ltspfs-0.5.8-1.fc10.x86_64

How reproducible:
100%

Steps to Reproduce:
1. strace cat /media/ellson/FEDORA/syslinux/boot.cat
2.
3.
  
Actual results:
...
open("/media/ellson/FEDORA/syslinux/boot.cat", O_RDONLY) = 3
fstat(3, {st_mode=S_IFREG|0755, st_size=2048, ...}) = 0
read(3, 0x2580000, 4096)                = -1 ENOMEM (Cannot allocate memory)
write(2, "cat: "..., 5cat: )                 = 5
write(2, "/media/ellson/FEDORA/syslinux/boo"..., 38/media/ellson/FEDORA/syslinux/boot.cat) = 38
open("/usr/share/locale/locale.alias", O_RDONLY) = 4
fstat(4, {st_mode=S_IFREG|0644, st_size=2512, ...}) = 0
mmap(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS, -1, 0) = 0x7f2088524000
read(4, "# Locale name alias data base.\n# "..., 4096) = 2512
read(4, ""..., 4096)                    = 0
close(4)                                = 0
munmap(0x7f2088524000, 4096)            = 0
open("/usr/share/locale/en_US.UTF-8/LC_MESSAGES/libc.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en_US.utf8/LC_MESSAGES/libc.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en_US/LC_MESSAGES/libc.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en.UTF-8/LC_MESSAGES/libc.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en.utf8/LC_MESSAGES/libc.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
open("/usr/share/locale/en/LC_MESSAGES/libc.mo", O_RDONLY) = -1 ENOENT (No such file or directory)
write(2, ": Cannot allocate memory"..., 24: Cannot allocate memory) = 24
write(2, "\n"..., 1
)                    = 1
close(3)                                = 0
close(1)                                = 0
close(2)                                = 0
exit_group(1)                           = ?


Expected results:
ability to open files on usb memory sticks

Additional info:
Comment 1 Warren Togami 2009-02-10 20:47:31 EST
This is extremely bizarre.  Ryan, any ideas?
Comment 2 John Ellson 2009-06-03 10:31:19 EDT
We still have this problem on the school system.   On my home sytstem, USB memory sticks work just fine. I've reloaded the ltsp-client software on both systems to be sure they are identical.   I've checked everything I can think of on the servers, but can't find any differences.


The symptoms are:
- Plugin a USB stick and it shows on the desktop, but attempting to read or write a file to it results in a gui popup:

    Error reading from file: cannot allocate memory

- The mount point is weird, even root can't access it:

    root@sol:~# cd /media/test3
    root@sol:test3# ls -l
    ls: cannot access CANON_DC: Permission denied
    total 0
    d????????? ? ? ? ?                ? CANON_DC

- Mount on the server shows:

    gvfs-fuse-daemon on /home/test3/.gvfs type fuse.gvfs-fuse-daemon (rw,nosuid,nodev,user=test3)
    ltspfs on /media/test3/CANON_DC type fuse.ltspfs (rw,nosuid,nodev,user=test3)



Any ideas?   What should I investigate for permissions problems on gvfs mounts?
Comment 3 Warren Togami 2009-06-03 13:59:47 EDT
I cannot prioritize looking at this.  did you ask upstream?  they wrote and understand this part of the code.
Comment 4 John Ellson 2009-08-19 10:35:44 EDT
Tried completely fresh install of fedora-11 and still the same problem,
but finally some new information.

This bug affects x86_64 ltsp clients only!   i386 clients work fine.


Mounting the memory stick works, but trying to read or write to it fails with:

    ellson@bock:usbdisk-sda1> cat foo
    cat: foo: Cannot allocate memory

I suspect this code in ltspfsd (also the similar malloc in ltspfs_write() )


void ltspfs_read(int sockfd, XDR * in)
{
    XDR out;
    char path[PATH_MAX];
    char output[LTSP_MAXBUF];
    int i;
    int fd;
    int result;
    size_t size;
    off_t offset;
    char *buf;

    if (!xdr_u_int(in, &size)) {                 /* Get the size */
        eacces(sockfd);
        return;
    }

    if (!xdr_longlong_t(in, &offset)) {          /* Get the offset */
        eacces(sockfd);
        return;
    }

    if (get_fn(sockfd, in, path)) {              /* Get the path */
        eacces(sockfd);
        return;
    }


    buf = malloc(size);

    /*
     * Check result of malloc
     */

    if (!buf) {
        status_return(sockfd, FAIL);
        return;
    }



Partularly since this code is generating these build warnings!

ake[2]: Entering directory `/home/ellson/rpmbuild/BUILD/ltspfs-0.5.8/src'
/usr/bin/gcc -DHAVE_CONFIG_H -I. -I..    -Wall -W -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=22 -D_REENTRANT -g -O2 -MT ltspfs-ltspfs.o -MD -MP -MF .deps/ltspfs-ltspfs.Tpo -c -o ltspfs-ltspfs.o `test -f 'ltspfs.c' || echo './'`ltspfs.c
ltspfs.c: In function ‘ltspfs_getattr’:
ltspfs.c:312: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘__nlink_t *’
ltspfs.c: In function ‘ltspfs_read’:
ltspfs.c:766: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘size_t *’
ltspfs.c: In function ‘ltspfs_write’:
ltspfs.c:823: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘size_t *’
ltspfs.c: In function ‘ltspfs_statfs’:
ltspfs.c:882: warning: passing argument 2 of ‘xdr_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:288: note: expected ‘int *’ but argument is of type ‘long int *’
ltspfs.c:883: warning: passing argument 2 of ‘xdr_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:288: note: expected ‘int *’ but argument is of type ‘long int *’
ltspfs.c:889: warning: passing argument 2 of ‘xdr_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:288: note: expected ‘int *’ but argument is of type ‘long int *’
mv -f .deps/ltspfs-ltspfs.Tpo .deps/ltspfs-ltspfs.Po
/usr/bin/gcc -DHAVE_CONFIG_H -I. -I..    -Wall -W -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=22 -D_REENTRANT -g -O2 -MT ltspfs-common.o -MD -MP -MF .deps/ltspfs-common.Tpo -c -o ltspfs-common.o `test -f 'common.c' || echo './'`common.c
mv -f .deps/ltspfs-common.Tpo .deps/ltspfs-common.Po
/usr/bin/gcc -Wall -W -D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=22 -D_REENTRANT -g -O2   -o ltspfs ltspfs-ltspfs.o ltspfs-common.o -pthread -L/lib64 -lfuse -lrt -ldl -lX11   
/usr/bin/gcc -DHAVE_CONFIG_H -I. -I..    -Wall -W -D_FILE_OFFSET_BITS=64 -DAUTOMOUNT -D_REENTRANT -g -O2 -MT ltspfsd-ltspfsd.o -MD -MP -MF .deps/ltspfsd-ltspfsd.Tpo -c -o ltspfsd-ltspfsd.o `test -f 'ltspfsd.c' || echo './'`ltspfsd.c
mv -f .deps/ltspfsd-ltspfsd.Tpo .deps/ltspfsd-ltspfsd.Po
/usr/bin/gcc -DHAVE_CONFIG_H -I. -I..    -Wall -W -D_FILE_OFFSET_BITS=64 -DAUTOMOUNT -D_REENTRANT -g -O2 -MT ltspfsd-ltspfsd_functions.o -MD -MP -MF .deps/ltspfsd-ltspfsd_functions.Tpo -c -o ltspfsd-ltspfsd_functions.o `test -f 'ltspfsd_functions.c' || echo './'`ltspfsd_functions.c
ltspfsd_functions.c: In function ‘ltspfs_getattr’:
ltspfsd_functions.c:238: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘__nlink_t *’
ltspfsd_functions.c: In function ‘ltspfs_read’:
ltspfsd_functions.c:700: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘size_t *’
ltspfsd_functions.c: In function ‘ltspfs_write’:
ltspfsd_functions.c:776: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘size_t *’
ltspfsd_functions.c: In function ‘ltspfs_statfs’:
ltspfsd_functions.c:864: warning: passing argument 2 of ‘xdr_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:288: note: expected ‘int *’ but argument is of type ‘long int *’
ltspfsd_functions.c:865: warning: passing argument 2 of ‘xdr_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:288: note: expected ‘int *’ but argument is of type ‘long int *’
ltspfsd_functions.c:871: warning: passing argument 2 of ‘xdr_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:288: note: expected ‘int *’ but argument is of type ‘long int *’
ltspfsd_functions.c: In function ‘handle_auth’:
ltspfsd_functions.c:950: warning: passing argument 2 of ‘xdr_u_int’ from incompatible pointer type
/usr/include/rpc/xdr.h:289: note: expected ‘u_int *’ but argument is of type ‘size_t *’
mv -f .deps/ltspfsd-ltspfsd_functions.Tpo .deps/ltspfsd-ltspfsd_functions.Po





I'd report this "upstream" but don't know where that is.  The ltsp.spec lists
https://code.launchpad.net/ltspfs, but try to report a bug there and you get:
    LtspFS (Unspecified)  does not use Launchpad as its bug tracker. 

The Launchpad pages list Scott Balneaves as the maintainer, so I'll try adding him to needinfo.
Comment 5 John Ellson 2009-08-19 10:53:46 EDT
I think I found the right place to report it:

https://bugs.launchpad.net/ltsp/+bug/415952
Comment 6 Bug Zapper 2009-11-18 06:02:48 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 John Ellson 2009-12-01 10:19:24 EST
This problem still exists in Fedora 11.
Comment 8 Bug Zapper 2010-04-27 08:53:01 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Bug Zapper 2010-06-28 07:12:50 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.